#ifndef VETTORE_T_H_
#define VETTORE_T_H_

#include <iostream>
using namespace std;

#define DIM_INIZIALE 10;

template <class X> class Vettore{
    X *p;
    int sizeAttuale, dimAttuale, incremento, dimIniziale;
public:
    Vettore(){
        dimIniziale = DIM_INIZIALE;
        dimAttuale = DIM_INIZIALE;
        incremento = DIM_INIZIALE;
        sizeAttuale = 0;
        p = new X[dimIniziale];
    }
            
    Vettore(int dimIniziale, int incremento){
        if (dimIniziale <= 0){
            p = NULL;
            this->dimIniziale = 0;
            this->dimAttuale = 0;
            this->incremento = 0;
        } else {
            p = new X[dimIniziale];
            this->dimIniziale = dimIniziale;
            this->dimAttuale = dimIniziale;
            this->incremento = incremento;
        }
        this->sizeAttuale = 0;
    }

    Vettore(const Vettore<X> &v){
        dimIniziale = v.dimIniziale;
        dimAttuale = v.dimAttuale;
        sizeAttuale = v.sizeAttuale;
        incremento = v.incremento;
        p = new X[v.dimAttuale];
        for(int i = 0; i < v.sizeAttuale; i++){
            p[i] = v.p[i];
        }
    }


    ~Vettore(){
        delete[] p;
    }

    
    // Aggiunge in coda al vettore un nuovo oggetto (passaggio per copia)
    void add(X c){
        if (sizeAttuale >= dimAttuale){
            dimAttuale = dimAttuale + incremento;
            X *temp = new X[dimAttuale];
            for(int i = 0; i < sizeAttuale; i++){
                temp[i] = p[i];
            }
            delete[] p;
            p = temp;
        }
        p[sizeAttuale++] = c;
    }

    // Preleva l'oggetto in posizione index dal vettore
    X get(int index){
        return p[index];
    }
    // Fornisce il riempimento attuale del vettore
    int size(){
        return sizeAttuale;
    }
    // Stampa a video tutti gli oggetti contenuti
    friend istream & operator >>(istream &i, Vettore<X> &v){
        X app;
        while(!i.eof()){
            i >> app;
            if (!i.eof())
                v.add(app);
        }
        return i;
    }

    // Stampa a video tutti gli oggetti contenuti
    friend ostream & operator <<(ostream &o, Vettore<X> v){
        for(int i = 0; i< v.sizeAttuale; i++){
            //cout << v.p[i] << endl;
            o << v.p[i] << endl;
        }
        return o;
    }
    
    
    Vettore <X> operator+(Vettore<X> v){
        Vettore <X> app(0,0); // Perchè conviene 0,0!?
        app.dimAttuale = this->dimAttuale + v.dimAttuale;
        app.sizeAttuale = this->sizeAttuale + v.sizeAttuale;
        app.incremento = this->incremento;
        app.dimIniziale = this->dimIniziale;
        app.p = new X[app.dimAttuale];
        for(int i = 0; i < this->sizeAttuale; i++){
            app.p[i] = this->p[i];
        }
        for(int i = 0; i < v.sizeAttuale; i++){
            app.p[i + this->sizeAttuale] = v.p[i];
        }
        return app;
    }

    
    
    Vettore<X> operator=(Vettore<X> v){
        // Ripulisci il vettore corrente (che si trova a sinistra dell'operatore di
        // assegnazione
        clear();
        // ricopia nel vettore corrente tutti gli elementi di v
        for(int i = 0; i < v.size(); i++){
            // o in alternativa si poteva scrivere: this->add(v.p[i]);
            add(v.p[i]);
        }
        // Restituisce una copia del vettore per assegnazioni in cascata
        return *this;
    }

    
    // Azzera il contenuto del vettore, deallocando tutti gli oggetti 
    // precedentemente contenuti e riportandolo alle dimensioni iniziali.
    void clear(){
        delete []p;
        dimAttuale = dimIniziale;
        p = new X[dimIniziale];
        sizeAttuale = 0;
    }

};

#endif
